diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/nntplib.c tin-2.6.5/src/nntplib.c
--- tin-2.6.4/src/nntplib.c	2024-12-21 02:56:55.000000000 +0100
+++ tin-2.6.5/src/nntplib.c	2025-12-18 19:40:47.309138047 +0100
@@ -2233,25 +2438,129 @@ DEBUG_IO((stderr, "new_nntp_command(%s)\
 }
 
 
+static void
+list_distributions(
+	void)
+{
+	char *ptr, *dist, *desc;
+	t_distrib_pat *p, *q;
+
+	if (!nntp_caps.list_distrib_pats || !nntp_caps.list_distributions || !nntp_caps.distrib_pats)
+		return;
+
+	switch (new_nntp_command("LIST DISTRIBUTIONS", OK_GROUPS, NULL, 0)) {
+		case OK_GROUPS:
+			while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
+#	ifdef DEBUG
+				if (debug & DEBUG_NNTP)
+					debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
+#	endif /* DEBUG */
+				if ((desc = strpbrk(ptr, " \t")) == NULL)
+					continue;
+				*desc++ = '\0';
+				dist = ptr;
+				for (p = nntp_caps.distrib_pats; p != NULL; p = q) {
+					if (!strcasecmp(p->distribution, dist)) {
+						FreeIfNeeded(p->description);
+						p->description = str_trim(utf8_valid(my_strdup(desc))); /* TODO: csguess_convert_str(..., "UTF-8")? */
+						break;
+					}
+					q = p->next;
+				}
+				if (p == NULL)
+					add_distrib_pat(0, NULL, dist, desc);
+			}
+			break;
+
+		default:
+			nntp_caps.list_distributions = FALSE;
+			break;
+	}
+	return;
+}
+
+
+static void
+list_distrib_pats(
+	void)
+{
+	char *ptr, *d, *pat, *dist;
+	int weight;
+
+	if (!nntp_caps.list_distrib_pats)
+		return;
+
+	switch (new_nntp_command("LIST DISTRIB.PATS", OK_GROUPS, NULL, 0)) {
+		case OK_GROUPS:
+			while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
+#	ifdef DEBUG
+				if (debug & DEBUG_NNTP)
+					debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
+#	endif /* DEBUG */
+				if ((d = strpbrk(ptr, ":")) == NULL)
+					continue;
+				weight = strtol(ptr, NULL, 10);
+				pat = d + 1;
+				if ((d = strpbrk(pat, ":")) == NULL)
+					continue;
+				*d = '\0';
+				dist = d + 1;
+				if (*dist && *pat)
+					nntp_caps.distrib_pats = add_distrib_pat(weight, pat, dist, NULL);
+			}
+			break;
+
+		default:
+			nntp_caps.list_distrib_pats = FALSE;
+			break;
+	}
+}
+
+
+static t_distrib_pat *
+add_distrib_pat(
+	int weight,
+	const char *pat,
+	const char *dist,
+	const char *desc)
+{
+	t_distrib_pat *p, *temp;
+
+	assert(((void) "add_distrib_pat() failed. dist == NULL", dist != NULL));
+
+	temp = my_malloc(sizeof *temp);
+	temp->weight = weight;
+	temp->pattern = pat ? my_strdup(pat) : NULL;
+	temp->distribution = my_strdup(dist);
+	temp->description = desc ? my_strdup(desc) : NULL;
+	temp->next = NULL;
+
+	if (nntp_caps.distrib_pats == NULL)
+		nntp_caps.distrib_pats = temp;
+	else {
+		p = nntp_caps.distrib_pats;
+		while (p->next != NULL)
+			p = p->next;
+		p->next = temp;
+	}
+
+	return nntp_caps.distrib_pats;
+}
+
+
 static long int
 list_motd(
 	FILE *stream)
 {
 	char *ptr, *p, *m;
-	char buf[NNTP_STRLEN];
-	size_t len;
 	long m_hash = 0L;
-#	if defined(CHARSET_CONVERSION) && defined(USE_ICU_UCSDET)
-	char *guessed_charset;
-#	endif /* CHARSET_CONVERSION && USE_ICU_UCSDET */
 
-	if (!stream)
+	if (!stream || !nntp_caps.list_motd)
 		return m_hash;
 
 	m = my_calloc(1, 1);
-	buf[0] = '\0';
 
-	switch (new_nntp_command("LIST MOTD", OK_MOTD, buf, sizeof(buf))) {
+	switch (new_nntp_command("LIST MOTD", OK_MOTD, NULL, 0)) {
 		case OK_MOTD:
 			while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
 #	ifdef DEBUG
@@ -2259,7 +2568,6 @@ list_motd(
 					debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
 #	endif /* DEBUG */
 				p = my_strdup(ptr);
-				len = strlen(p);
 
 				/* original MOTD for hashing as local charset may change */
 				m = append_to_string(m, p);
@@ -2271,14 +2579,7 @@ list_motd(
 				 * so checking nntp_caps.type doesn't help and we guess if
 				 * we can. Some day we may check for nntp_caps.version > 2 ...
 				 */
-#	if defined(CHARSET_CONVERSION) && defined(USE_ICU_UCSDET)
-				if ((guessed_charset = guess_charset(p, 10)) != NULL) {
-					process_charsets(&p, &len, guessed_charset, tinrc.mm_local_charset, FALSE);
-					free(guessed_charset);
-				} else
-#	endif /* CHARSET_CONVERSION && USE_ICU_UCSDET */
-					process_charsets(&p, &len, "UTF-8", tinrc.mm_local_charset, FALSE);
-
+				csguess_convert_str(&p, "UTF-8");
 				fprintf(stream, _(txt_motd), p);
 				free(p);
 			}
@@ -2365,6 +2666,7 @@ deflate_free(
 
 static z_streamp
 z_stream_init(
+	unsigned char *io_buf,
 	t_bool is_deflate)
 {
 	int result;
@@ -2372,14 +2674,25 @@ z_stream_init(
 	z_streamp strm = my_calloc(1, sizeof(z_stream));
 	strm->zalloc = deflate_alloc;
 	strm->zfree = deflate_free;
+	strm->opaque = NULL;
 
-	if (is_deflate)
+	if (is_deflate) {
+		strm->next_out = io_buf;
+		strm->avail_out = DEFLATE_BUFSZ;
 		result = deflateInit2(strm, Z_DEFAULT_COMPRESSION, Z_DEFLATED, -15, 8, Z_DEFAULT_STRATEGY);
-	else
+	} else {
+		strm->next_in = io_buf;
+		strm->avail_in = 0;
 		result = inflateInit2(strm, -15);
+	}
 
-	if (result != Z_OK)
+	if (result != Z_OK) {
+		if (is_deflate)
+			deflateEnd(strm);
+		else
+			inflateEnd(strm);
 		FreeAndNull(strm);
+	}
 
 	return strm;
 }
@@ -2387,29 +2700,20 @@ z_stream_init(
 
 static void
 enable_deflate(
-	struct nntpbuf* nntpbuf)
+	struct nntpbuf *nntpbuf)
 {
-	char buf[NNTP_STRLEN];
-
 	if (nntpbuf->z_rd || nntpbuf->z_wr)
 		return;
 
-	nntpbuf->z_rd = z_stream_init(FALSE);
-	nntpbuf->z_wr = z_stream_init(TRUE);
+	nntpbuf->z_rd_buf = my_malloc(DEFLATE_BUFSZ);
+	nntpbuf->z_wr_buf = my_malloc(DEFLATE_BUFSZ);
+	nntpbuf->z_rd = z_stream_init(nntpbuf->z_rd_buf, FALSE);
+	nntpbuf->z_wr = z_stream_init(nntpbuf->z_wr_buf, TRUE);
 
 	if (nntpbuf->z_rd == NULL || nntpbuf->z_wr == NULL)
 		goto error_out;
 
-	nntpbuf->z_rd_buf = my_malloc(DEFLATE_BUFSZ);
-	nntpbuf->z_rd->next_in = nntpbuf->z_rd_buf;
-	nntpbuf->z_rd->avail_in = 0;
-
-	nntpbuf->z_wr_buf = my_malloc(DEFLATE_BUFSZ);
-	nntpbuf->z_wr->next_out = nntpbuf->z_wr_buf;
-	nntpbuf->z_wr->avail_out = DEFLATE_BUFSZ;
-
-	buf[0] = '\0';
-	switch (new_nntp_command("COMPRESS DEFLATE", OK_COMPRESS, buf, sizeof(buf))) {
+	switch (new_nntp_command("COMPRESS DEFLATE", OK_COMPRESS, NULL, 0)) {
 		case OK_COMPRESS:
 			deflate_active = TRUE;
 			return;
@@ -2430,7 +2734,7 @@ error_out:
 
 static ssize_t
 nntpbuf_deflate_write(
-	struct nntpbuf* buf)
+	struct nntpbuf *buf)
 {
 	ssize_t bytes_written = 0, bwritten;
 	t_bool deflate_again = TRUE;
@@ -2458,6 +2762,8 @@ nntpbuf_deflate_write(
 			bytes_written += bwritten;
 		}
 	}
+
+	buf->z_wr->next_out = buf->z_wr_buf;
 	buf->wr.lb = buf->wr.ub;
 
 	return bytes_written;
@@ -2466,7 +2772,7 @@ nntpbuf_deflate_write(
 
 static ssize_t
 nntpbuf_inflate(
-	struct nntpbuf* buf)
+	struct nntpbuf *buf)
 {
 	int result = inflate(buf->z_rd, Z_NO_FLUSH);
 
@@ -2483,7 +2789,7 @@ nntpbuf_inflate(
 
 static ssize_t
 nntpbuf_inflate_read(
-	struct nntpbuf* buf)
+	struct nntpbuf *buf)
 {
 	ssize_t bytes_read;
 	ssize_t bread;
@@ -2519,7 +2825,7 @@ nntpbuf_inflate_read(
  */
 static int
 nntpbuf_flush(
-	struct nntpbuf* buf)
+	struct nntpbuf *buf)
 {
 	if (!buf)
 		return EOF;
@@ -2551,8 +2857,8 @@ nntpbuf_flush(
  */
 static int
 nntpbuf_puts(
-	const char* data,
-	struct nntpbuf* buf)
+	const char *data,
+	struct nntpbuf *buf)
 {
 	int bytes_written = 0, retval;
 	size_t len, l;
@@ -2712,12 +3018,16 @@ nntpbuf_close(
 		if (result != 0) {
 			/* TODO: warn? */
 		}
+#	ifdef USE_OPENSSL
+		else
+			buf->fd = -1;
+#	endif /* USE_OPENSSL */
 	}
 	buf->tls_ctx = NULL;
 #	endif /* NNTPS_ABLE */
 
 	if (buf->fd >= 0)
-		close(buf->fd);
+		sync_close(buf->fd);
 
 	buf->fd = -1;
 
@@ -2770,7 +3080,7 @@ nntp_conninfo(
 	fprintf(stream, _(txt_conninfo_server), nntp_server);
 	fprintf(stream, _(txt_conninfo_port), nntp_tcp_port);
 
-#	if defined(HAVE_GETPEERNAME) || defined(TLI)
+#	if defined(HAVE_GETSOCKOPT) || defined(HAVE_GETPEERNAME) || defined(TLI)
 	switch (nntp_buf.family) {
 		case AF_INET:
 			fprintf(stream, _(txt_conninfo_type), "IPv4");
@@ -2794,12 +3104,36 @@ nntp_conninfo(
 #		endif /* DEBUG */
 			break;
 	}
-#	endif /* HAVE_GETPEERNAME || TLI */
+#	endif /* HAVE_GETSOCKOPT || HAVE_GETPEERNAME || TLI */
+
+#	if defined(HAVE_ALARM) && defined(SIGALRM)
+	fprintf(stream, P_(txt_conninfo_timeout_sp[0], txt_conninfo_timeout_sp[1], TIN_NNTP_TIMEOUT), TIN_NNTP_TIMEOUT, TIN_NNTP_TIMEOUT ? "" : _(txt_conninfo_disabled));
+#	endif /* HAVE_ALARM && SIGALRM */
+
+#	if defined(TIMEOUT_TYPE) && defined(TIMEOUT_INI_NAME) && defined(DEBUG)
+	/* as this is for debugging only, intentionally no _() here */
+	{
+		TIMEOUT_TYPE ival;
+		socklen_t vlen = sizeof(TIMEOUT_TYPE);
+		int l = strlen(_(txt_conninfo_type)) - 5; /* 5 == ": %s\n" */
+
+		if (getsockopt(nntp_buf.fd, IPPROTO_TCP, TIMEOUT_INI_NAME, &ival, &vlen) == 0) {
+#		ifdef TCP_USER_TIMEOUT
+			/* this actually is TIMEOUT_RXT_NAME */
+			fprintf(stream, "%-*.*s: %s %u.%.3u seconds\n", l, l, "TCP TIMEOUTS", "TCP_USER_TIMEOUT", ival / TIMEOUT_MUL, ival % TIMEOUT_MUL);
+#		else
+#			if defined(TCP_CONNECTIONTIMEOUT) && defined(TCP_RXT_CONNDROPTIME)
+			fprintf(stream, "%-*.*s: %s %-5d seconds\n", l, l, "TCP TIMEOUTS", "TCP_CONNECTIONTIMEOUT", ival); /* 5 == snprintf(NULL, 0, "%d", TIN_NNTP_TIMEOUT_MAX) */
+			if (getsockopt(nntp_buf.fd, IPPROTO_TCP, TIMEOUT_RXT_NAME, &ival, &vlen) == 0)
+				fprintf(stream, "%-*.*s %s %-5d seconds", l + 1, l + 1, "", "TCP_RXT_CONNDROPTIME ", ival);
+			fprintf(stream, "\n");
+#			endif /* TCP_CONNECTIONTIMEOUT && TCP_RXT_CONNDROPTIME */
+#		endif /* TCP_USER_TIMEOUT */
+		}
+	}
+#	endif /* TIMEOUT_TYPE && TIMEOUT_INI_NAME && DEBUG */
 
 	if (nntp_caps.type == CAPABILITIES) {
-		fprintf(stream, "\n");
-		if (nntp_caps.implementation && *nntp_caps.implementation)
-			fprintf(stream, _(txt_conninfo_implementation), nntp_caps.implementation);
 		if (nntp_caps.compress) {
 			fprintf(stream, "%s", _(txt_conninfo_compress));
 			if ((nntp_caps.compress_algorithm & COMPRESS_DEFLATE) == COMPRESS_DEFLATE) {
@@ -2809,35 +3143,35 @@ nntp_conninfo(
 				fprintf(stream, "%s", _(txt_conninfo_deflate_unsupported));
 #	endif /* USE_ZLIB */
 			}
-		}
 #	if defined(MAXARTNUM) && defined(USE_LONG_ARTICLE_NUMBERS)
-		if (nntp_caps.maxartnum) {
-			char *buf;
-			int n;
-			size_t len;
-
-			if ((n = snprintf(NULL, 0, "%"T_ARTNUM_PFMT, nntp_caps.maxartnum)) > 0) {
-				len = (size_t) n + 1;
-				buf = my_malloc(len);
-
-				if (snprintf(buf, len, "%"T_ARTNUM_PFMT, nntp_caps.maxartnum) == n)
-					fprintf(stream, _(txt_conninfo_maxartnum), buf);
-				free(buf);
+			if (nntp_caps.maxartnum) {
+				char *buf;
+				int n;
+				size_t len;
+
+				if ((n = snprintf(NULL, 0, "%"T_ARTNUM_PFMT, nntp_caps.maxartnum)) > 0) {
+					len = (size_t) n + 1;
+					buf = my_malloc(len);
+
+					if (snprintf(buf, len, "%"T_ARTNUM_PFMT, nntp_caps.maxartnum) == n)
+						fprintf(stream, _(txt_conninfo_maxartnum), buf);
+					free(buf);
+				}
 			}
-		}
 #	endif /* MAXARTNUM && USE_LONG_ARTICLE_NUMBERS */
-	}
-
-#	if defined(HAVE_ALARM) && defined(SIGALRM)
-	fprintf(stream, _(txt_conninfo_timeout), TIN_NNTP_TIMEOUT, TIN_NNTP_TIMEOUT ? "" : _(txt_conninfo_disabled));
-#	endif /* HAVE_ALARM && SIGALRM */
-
 #	ifdef USE_GSASL
-	if (nntp_caps.type == CAPABILITIES && nntp_caps.authinfo_sasl) {
-		fprintf(stream, _(txt_usable_sasl_mechs), nntp_caps.sasl_mechs ? nntp_caps.sasl_mechs : _(txt_none));
-		fprintf(stream, _(txt_used_sasl_mech), nntp_caps.sasl_mech_used ? nntp_caps.sasl_mech_used : _(txt_none));
-	}
+			if (nntp_caps.authinfo_sasl) {
+				fprintf(stream, _(txt_usable_sasl_mechs), nntp_caps.sasl_mechs ? nntp_caps.sasl_mechs : _(txt_none));
+				fprintf(stream, _(txt_used_sasl_mech), nntp_caps.sasl_mech_used ? nntp_caps.sasl_mech_used : _(txt_none));
+			}
 #	endif /* USE_GSASL */
+			if (nntp_caps.implementation && *nntp_caps.implementation)
+				fprintf(stream, _(txt_conninfo_implementation), nntp_caps.implementation);
+		}
+	}
+
+	if (*serverrc.disabled_nntp_cmds)
+		fprintf(stream, _(txt_disabled_cmds), serverrc.disabled_nntp_cmds);
 
 	{
 		char *motd;
@@ -2858,6 +3192,8 @@ nntp_conninfo(
 		retval = tintls_conninfo(nntp_buf.tls_ctx, stream);
 #	endif /* NNTPS_ABLE */
 
+	/* TODO: display distributions? */
+
 	return retval;
 }
 
@@ -2871,7 +3207,6 @@ set_maxartnum(
 	t_bool reconnect)
 {
 	char cmd[NNTP_STRLEN];
-	char line[NNTP_STRLEN] = { '\0' };
 	static int cnt = 0;
 
 	if (nntp_caps.maxartnum < T_ARTNUM_CONST(2147483647) || (!reconnect && cnt))
@@ -2881,7 +3216,7 @@ set_maxartnum(
 
 	snprintf(cmd, sizeof(cmd), "MAXARTNUM %"T_ARTNUM_PFMT, nntp_caps.maxartnum);
 
-	switch (new_nntp_command(cmd, OK_EXTENSIONS, line, sizeof(line))) {
+	switch (new_nntp_command(cmd, OK_EXTENSIONS, NULL, 0)) {
 		case OK_EXTENSIONS:
 			nntp_caps.mode_reader = FALSE;
 			nntp_caps.reader = TRUE;
@@ -2895,4 +3230,121 @@ set_maxartnum(
 	}
 }
 #	endif /* MAXARTNUM && USE_LONG_ARTICLE_NUMBERS */
+
+
+/*
+ * timeout for new, non established TCP connections
+ * return timeout in ms if any or -1 on error
+ */
+static long
+set_tcp_user_ini_timeout(
+	int sockfd,
+	t_bool set)
+{
+#	if defined(TIMEOUT_INI_NAME)
+	if (TIN_NNTP_TIMEOUT) {
+		TIMEOUT_TYPE optval = set ? (TIN_NNTP_TIMEOUT + 1) * TIMEOUT_MUL : 250;
+		TIMEOUT_TYPE ival;
+		socklen_t vlen = sizeof(TIMEOUT_TYPE);
+
+		if (setsockopt(sockfd, IPPROTO_TCP, TIMEOUT_INI_NAME, &optval, sizeof(TIMEOUT_TYPE)) != 0) {
+			DEBUG_IO((stderr, "%ssetsockopt(,TCP_INI_TIMEOUT,%u,) %s\n", logtime(), optval, strerror(errno)));
+			return -1L;
+		} else {
+			if (getsockopt(sockfd, IPPROTO_TCP, TIMEOUT_INI_NAME, &ival, &vlen) != 0) {
+				DEBUG_IO((stderr, "%sgetsockopt(,TCP_INI_TIMEOUT,): %s\n", logtime(), strerror(errno)));
+				return -1L;
+			} else {
+				DEBUG_IO((stderr, "%sgetsockopt(,TCP_INI_TIMEOUT,): %d\n", logtime(), ival));
+				return (long) ival * 1000 / TIMEOUT_MUL;
+			}
+		}
+	}
+#	else
+	DEBUG_IO((stderr, "%s!TIMEOUT_INI_NAME\n", logtime()));
+	(void) sockfd;
+	(void) set;
+#	endif /* TIMEOUT_INI_NAME */
+	return 0L;
+}
+
+
+/*
+ * tcp retransmissions timeout
+ * return set timeout in ms if any or -1 on error
+ */
+static long
+set_tcp_user_rxt_timeout(
+	int sockfd,
+	t_bool set)
+{
+#	if defined(TIMEOUT_RXT_NAME)
+	if (TIN_NNTP_TIMEOUT) {
+		TIMEOUT_TYPE optval = 250 + (set ? (TIN_NNTP_TIMEOUT < 12 ? TIN_NNTP_TIMEOUT * 500 : 6000) : 0);
+		TIMEOUT_TYPE ival;
+		socklen_t vlen = sizeof(TIMEOUT_TYPE);
+
+#	if defined(TIMEOUT_DIV) && TIMEOUT_DIV > 1
+		optval /= TIMEOUT_DIV;
+		if (!optval)
+			++optval;
+#	endif /* TIMEOUT_DIV && TIMEOUT_DIV > 1 */
+
+		if (setsockopt(sockfd, IPPROTO_TCP, TIMEOUT_RXT_NAME, &optval, sizeof(TIMEOUT_TYPE)) != 0) {
+			DEBUG_IO((stderr, "%ssetsockopt(,TCP_RXT_TIMEOUT,%u,) %s\n", logtime(), optval, strerror(errno)));
+			return -1L;
+		} else {
+			if (getsockopt(sockfd, IPPROTO_TCP, TIMEOUT_RXT_NAME, &ival, &vlen) != 0) {
+				DEBUG_IO((stderr, "%sgetsockopt(,TCP_RXT_TIMEOUT,): %s\n", logtime(), strerror(errno)));
+				return -1L;
+			} else {
+				DEBUG_IO((stderr, "%sgetsockopt(,TCP_RXT_TIMEOUT,): %d\n", logtime(), ival));
+#	if defined(TIMEOUT_DIV) && TIMEOUT_DIV > 1
+				return (long) ival * TIMEOUT_DIV;
+#	else
+				return (long) ival;
+#	endif /* TIMEOUT_DIV && TIMEOUT_DIV > 1 */
+			}
+		}
+	}
+#	else
+	DEBUG_IO((stderr, "%s!TIMEOUT_RXT_NAME\n",logtime()));
+	(void) sockfd;
+	(void) set;
+#	endif /* TIMEOUT_RXT_NAME */
+	return 0L;
+}
+
+
+t_bool
+nntp_list_active_grp(
+	const char *group,
+	char *moderated)
+{
+	/* try to fetch moderationm flag via "LIST ACTIVE grp" */
+	char *line;
+	char cmd[NNTP_STRLEN];
+	t_artnum ac_min = T_ARTNUM_CONST(1), ac_max = T_ARTNUM_CONST(0);
+	t_bool found = FALSE;
+
+	snprintf(cmd, sizeof(cmd), "LIST ACTIVE %s", group);
+	switch (new_nntp_command(cmd, OK_GROUPS, NULL, 0)) {
+		case OK_GROUPS:
+			while ((line = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
+#	ifdef DEBUG
+				if (debug & DEBUG_NNTP)
+					debug_print_file("NNTP", "<<<%s%s", logtime(), line);
+#	endif /* DEBUG */
+
+				parse_active_line(line, &ac_max, &ac_min, moderated);
+				found = TRUE;
+			}
+			break;
+
+		default:
+			break;
+		}
+
+		return found;
+}
 #endif /* NNTP_ABLE */
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/nntps.c tin-2.6.5/src/nntps.c
--- tin-2.6.4/src/nntps.c	2024-12-23 21:22:36.000000000 +0100
+++ tin-2.6.5/src/nntps.c	2025-11-13 02:22:52.799680039 +0100
@@ -3,9 +3,9 @@
  *  Module    : nntps.c
  *  Author    : E. Berkhan
  *  Created   : 2022-09-10
- *  Updated   : 2024-12-23
+ *  Updated   : 2025-08-14
  *  Notes     : simple abstraction for various TLS implementations
- *  Copyright : (c) Copyright 2022-2025 Enrik Berkhan <Enrik.Berkhan@inka.de>
+ *  Copyright : (c) Copyright 2022-2026 Enrik Berkhan <Enrik.Berkhan@inka.de>
  *              Permission is hereby granted to copy, reproduce, redistribute
  *              or otherwise use this software  as long as: there is no
  *              monetary  profit  gained  specifically  from the use or
@@ -33,9 +33,11 @@ static struct tls_config *libtls_config
 static gnutls_certificate_credentials_t tls_xcreds = NULL;
 static char *gnutls_servername = NULL;
 static unsigned gnutls_verification_status = 0;
+static gnutls_datum_t gtls_alpns[] = { { (unsigned char *) NNTP_TCP_NAME, 4 } };
 #	else
 #		ifdef USE_OPENSSL
 static SSL_CTX *openssl_ctx = NULL;
+static unsigned char nntp_alpn[] = { 4, 'n', 'n', 't', 'p' };
 #		endif /* USE_OPENSSL */
 #	endif /* USE_GNUTLS */
 #endif /* USE_LIBTLS */
@@ -70,7 +72,7 @@ tintls_init(
 {
 	char *ca_cert_file = ca_cert_file_expanded;
 #ifdef USE_GNUTLS
-	int result = 0;
+	int result;
 #endif /* USE_GNUTLS */
 
 	if (tinrc.tls_ca_cert_file && *tinrc.tls_ca_cert_file) {
@@ -111,6 +113,14 @@ tintls_init(
 		tls_config_insecure_noverifytime(libtls_config);
 	}
 
+	/* ALPN - Application-Layer Protocol Negotiation, RFC 7301 */
+	if (tls_config_set_alpn(libtls_config, NNTP_TCP_NAME)) {
+		error_message(2, "%s!\n", tls_config_error(libtls_config));
+		tls_config_free(libtls_config);
+		libtls_config = NULL;
+		return -EINVAL;
+	}
+
 #else
 #	ifdef USE_GNUTLS
 
@@ -187,6 +197,14 @@ tintls_init(
 		}
 	}
 
+	/* ALPN - Application-Layer Protocol Negotiation, RFC 7301 */
+	if (SSL_CTX_set_alpn_protos(openssl_ctx, nntp_alpn, (int) sizeof(nntp_alpn))) {
+		SSL_CTX_free(openssl_ctx);
+		openssl_ctx = NULL;
+		show_errors("SSL_CTX_set_alpn_protos: %s!\n");
+		return -EINVAL;
+	}
+
 	if (insecure_nntps)
 		SSL_CTX_set_verify(openssl_ctx, SSL_VERIFY_NONE, NULL);
 	else
@@ -275,6 +293,14 @@ tintls_open(
 	if (gnutls_init(&client, GNUTLS_CLIENT | GNUTLS_AUTO_REAUTH | GNUTLS_POST_HANDSHAKE_AUTH) < 0)
 		return -ENOMEM;
 
+	/* ALPN - Application-Layer Protocol Negotiation, RFC 7301 */
+	if (gnutls_alpn_set_protocols(client, gtls_alpns, 1, GNUTLS_ALPN_MANDATORY)) {
+		error_message(1, "%s", "failed setting ALPN");
+		gnutls_deinit(client);
+		return -EINVAL;
+	}
+
+	/* SNI - Server Name Indication, RFC 6066 */
 	if (gnutls_server_name_set(client, GNUTLS_NAME_DNS, servername, strlen(servername)) < 0) {
 		gnutls_deinit(client);
 		return -ENOMEM;
@@ -331,6 +357,16 @@ tintls_open(
 		return -EINVAL;
 	}
 
+	/* ALPN - Application-Layer Protocol Negotiation, RFC 7301 */
+	/* should not be needed as we already set it, but it doesn't hurt */
+	if (SSL_set_alpn_protos(ssl, nntp_alpn, (int) sizeof(nntp_alpn))) {
+		BIO_free(client);
+		BIO_free(sock);
+		show_errors("SSL_set_alpn_protos: %s!\n");
+		return -EINVAL;
+	}
+
+	/* SNI - Server Name Indication, RFC 6066 */
 	if (SSL_set_tlsext_host_name(ssl, servername) != 1) {
 		BIO_free(client);
 		BIO_free(sock);
@@ -428,6 +464,13 @@ tintls_handshake(
 
 		wait_message(0, _(txt_tls_handshake_done), version, cipher);
 	}
+
+#	ifdef DEBUG
+	if (debug & DEBUG_NNTP) {
+		if (tls_conn_alpn_selected(client) == NULL)
+			wait_message(0, _(txt_tls_no_alpn_negotiated));
+	}
+#	endif /* DEBUG */
 #else
 #	ifdef USE_GNUTLS
 	int result;
@@ -543,10 +586,18 @@ err_cert:
 		}
 
 		if (!batch_mode || verbose) {
+#		ifdef DEBUG
+			gnutls_datum_t alpn = { NULL, 0 };
+#		endif /* DEBUG */
+
 			if ((desc = gnutls_session_get_desc(client)) != NULL) {
 				wait_message(0, _(txt_tls_handshake_done), desc);
 				gnutls_free(desc);
 			}
+#		ifdef DEBUG
+			if ((debug & DEBUG_NNTP) && gnutls_alpn_get_selected_protocol(client, &alpn))
+				wait_message(0, _(txt_tls_no_alpn_negotiated));
+#		endif /* DEBUG */
 		}
 	}
 #	else
@@ -594,6 +645,17 @@ err_cert:
 		}
 
 		wait_message(0, _(txt_tls_handshake_done), SSL_get_cipher_name(ssl));
+
+#			ifdef DEBUG
+		if (debug & DEBUG_NNTP) {
+			const unsigned char *proto;
+			unsigned int proto_len;
+
+			SSL_get0_alpn_selected(ssl, &proto, &proto_len);
+			if (!proto_len)
+				wait_message(0, txt_tls_no_alpn_negotiated);
+		}
+#			endif /* DEBUG */
 	}
 #		endif /* USE_OPENSSL */
 #	endif /* USE_GNUTLS */
@@ -753,18 +815,34 @@ tintls_close(
 }
 
 
-/* TODO: make date-format configurable? */
-#define PRINT_VALID_AFTER(ts, what) do { \
-		if (my_strftime(what, sizeof(what), "%Y-%m-%dT%H:%M%z", ts)) \
-			fprintf(fp, _(txt_valid_not_after), (what)); \
-		else \
+/*
+ * TODO:
+ *      - make date-format configurable?
+ *      - format startup time only once, it is static
+ */
+#define PRINT_VALID_AFTER(ts, what, val) do { \
+		if (my_strftime(what, sizeof(what), "%Y-%m-%dT%H:%M%z", ts)) { \
+			fprintf(fp, _(txt_valid_not_after), (what), (val) ? "" : _(txt_valid_no_longer)); \
+			if (!val_time) { \
+				if (my_strftime(what, sizeof(what), "%Y-%m-%dT%H:%M%z", gmtime(&startup_time))) { \
+					fprintf(fp, _(txt_startup_time), (what)); \
+					fprintf(fp, "\n"); \
+				} \
+				val_time = TRUE; \
+			} \
+		} else \
 			fprintf(fp, "%s", txt_conninfo_fmt_error); \
 	} while (0)
 
-#define PRINT_VALID_BEFORE(ts, what) do { \
-		if (my_strftime(what, sizeof(what), "%Y-%m-%dT%H:%M%z", ts)) \
-			fprintf(fp, _(txt_valid_not_before), (what)); \
-		else \
+#define PRINT_VALID_BEFORE(ts, what, val) do { \
+		if (my_strftime(what, sizeof(what), "%Y-%m-%dT%H:%M%z", ts)) { \
+			fprintf(fp, _(txt_valid_not_before), (what), (val) ? "" : _(txt_valid_not_yet)); \
+			if (!val_time) { \
+				if (my_strftime(what, sizeof(what), "%Y-%m-%dT%H:%M%z", gmtime(&startup_time))) \
+					fprintf(fp, _(txt_startup_time), (what)); \
+				val_time = TRUE; \
+			} \
+		} else \
 			fprintf(fp, "%s", txt_conninfo_fmt_error); \
 	} while (0)
 
@@ -774,9 +852,9 @@ tintls_conninfo(
 	void *session_ctx,
 	FILE *fp)
 {
+	char fmt_time[22]; /* %Y-%m-%dT%H:%M%z */
 #ifdef USE_LIBTLS
 	struct tls *client = session_ctx;
-	char fmt_time[22]; /* %Y-%m-%dT%H:%M%z */
 #	ifdef HAVE_LIB_CRYPTO
 	BIO *io_buf = NULL;
 	const uint8_t *chain;
@@ -784,6 +862,8 @@ tintls_conninfo(
 
 	fprintf(fp, "%s", _(txt_conninfo_tls_info));
 	fprintf(fp, _(txt_conninfo_libtls_info), tls_conn_version(client), tls_conn_cipher(client), tls_conn_cipher_strength(client));
+	if (tls_conn_alpn_selected(client) == NULL)
+		fprintf(fp, "%s\n", _(txt_tls_no_alpn_negotiated));
 
 	if ((chain = tls_peer_cert_chain_pem(client, &chain_size)))
 		io_buf = BIO_new(BIO_s_mem());
@@ -796,6 +876,7 @@ tintls_conninfo(
 		int i;
 		size_t cl;
 		struct tm tm;
+		t_bool val_time = TRUE;
 
 		fprintf(fp, "%s", _(txt_conninfo_server_cert_info));
 
@@ -824,14 +905,24 @@ tintls_conninfo(
 
 					if ((asn1 = X509_get0_notBefore(cert)) != NULL) {
 						if (ASN1_TIME_to_tm(asn1, &tm) == 1) {
-							PRINT_VALID_BEFORE(&tm, fmt_time);
+#	ifdef HAVE_MKTIME
+							if (mktime(&tm) > startup_time)
+								val_time = FALSE;
+#	endif /* HAVE_MKTIME */
+							PRINT_VALID_BEFORE(&tm, fmt_time, val_time);
 						}
 					}
+
 					if ((asn1 = X509_get0_notAfter(cert)) != NULL) {
 						if (ASN1_TIME_to_tm(asn1, &tm) == 1) {
-							PRINT_VALID_AFTER(&tm, fmt_time);
+#	ifdef HAVE_MKTIME
+							if (mktime(&tm) < startup_time)
+								val_time = FALSE;
+#	endif /* HAVE_MKTIME */
+							PRINT_VALID_AFTER(&tm, fmt_time, val_time);
 						}
 					}
+
 					X509_free(cert);
 				}
 			}
@@ -845,37 +936,48 @@ tintls_conninfo(
 	fprintf(fp, "%s", _(txt_conninfo_tls_info));
 	fprintf(fp, _(txt_conninfo_libtls_info), tls_conn_version(client), tls_conn_cipher(client), tls_conn_cipher_strength(client));
 	fprintf(fp, "%s", _(txt_conninfo_server_cert_info));
+	if (tls_conn_alpn_selected(client) == NULL)
+		fprintf(fp, "%s\n", _(txt_tls_no_alpn_negotiated));
 #	endif /* HAVE_LIB_CRYPTO */
 	{
 		struct tm *tm;
 		time_t t;
+		t_bool val_time = TRUE;
 
 		fprintf(fp, _(txt_conninfo_subject), tls_peer_cert_subject(client));
 		fprintf(fp, _(txt_conninfo_issuer), tls_peer_cert_issuer(client));
 
 		if ((t = tls_peer_cert_notbefore(client)) != -1) {
 			tm = gmtime(&t);
-			PRINT_VALID_BEFORE(tm, fmt_time);
+#	ifdef HAVE_MKTIME
+			if (mktime(tm) > startup_time)
+				val_time = FALSE;
+#	endif /* HAVE_MKTIME */
+			PRINT_VALID_BEFORE(tm, fmt_time, val_time);
 		}
 
 		if ((t = tls_peer_cert_notafter(client)) != -1) {
 			tm = gmtime(&t);
-			PRINT_VALID_AFTER(tm, fmt_time);
+#	ifdef HAVE_MKTIME
+			if (mktime(tm) < startup_time)
+				val_time = FALSE;
+#	endif /* HAVE_MKTIME */
+			PRINT_VALID_AFTER(tm, fmt_time, val_time);
 		}
 	}
 #else
 #	ifdef USE_GNUTLS
 	char *desc;
-	char fmt_time[22]; /* %Y-%m-%dT%H:%M%z */
 	int retval = -1;
-	int result;
 	gnutls_session_t client = session_ctx;
 	gnutls_datum_t msg;
+	gnutls_datum_t alpn = { NULL, 0 };
 	const gnutls_datum_t *raw_servercert_chain;
 	unsigned int servercert_chainlen;
 	unsigned int i;
 	time_t t;
 	struct tm *tm;
+	t_bool val_time = TRUE;
 
 	desc = gnutls_session_get_desc(client);
 	fprintf(fp, "%s", _(txt_conninfo_tls_info));
@@ -887,11 +989,9 @@ tintls_conninfo(
 	if (gnutls_verification_status != 0) {
 		int type = gnutls_certificate_type_get2(client, GNUTLS_CTYPE_SERVER);
 
-		result = gnutls_certificate_verification_status_print(gnutls_verification_status, type, &msg, 0);
-
-		if (result == 0)
+		if (!gnutls_certificate_verification_status_print(gnutls_verification_status, type, &msg, 0))
 			fprintf(fp, _(txt_conninfo_verify_failed), msg.data,
-					insecure_nntps ? _(txt_conninfo_error_tolerated) : _(txt_conninfo_error_unexpected));
+				insecure_nntps ? _(txt_conninfo_error_tolerated) : _(txt_conninfo_error_unexpected));
 		else
 			fprintf(fp, "%s", _(txt_conninfo_verify_failed_no_reason));
 
@@ -899,6 +999,9 @@ tintls_conninfo(
 	} else
 		fprintf(fp, "%s", _(txt_conninfo_verify_successful));
 
+	if (gnutls_alpn_get_selected_protocol(client, &alpn))
+		fprintf(fp, "%s\n", _(txt_tls_no_alpn_negotiated));
+
 	raw_servercert_chain = gnutls_certificate_get_peers(client, &servercert_chainlen);
 	if (servercert_chainlen > 0)
 		fprintf(fp, "%s", _(txt_conninfo_server_cert_info));
@@ -907,60 +1010,64 @@ tintls_conninfo(
 		gnutls_x509_crt_t servercert = NULL;
 		gnutls_datum_t subject = { NULL, 0 };
 		gnutls_datum_t issuer = { NULL, 0 };
-#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
+#		if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 		char *sub;
 		char *iss;
 		size_t len_s;
 		size_t len_i;
-#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
+#		endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 
 		if (i)
 			fputs("\n", fp);
 		fprintf(fp, _(txt_conninfo_cert), i);
 
-		if ((result = gnutls_x509_crt_init(&servercert)) < 0)
+		if (gnutls_x509_crt_init(&servercert) < 0)
 			goto err_cert;
 
-		if ((result = gnutls_x509_crt_import(servercert, &raw_servercert_chain[i], GNUTLS_X509_FMT_DER)) < 0)
+		if (gnutls_x509_crt_import(servercert, &raw_servercert_chain[i], GNUTLS_X509_FMT_DER) < 0)
 			goto err_cert;
 
-		if ((result = gnutls_x509_crt_get_dn3(servercert, &subject, 0)) < 0)
+		if (gnutls_x509_crt_get_dn3(servercert, &subject, 0) < 0)
 			goto err_cert;
 		else {
-#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
+#		if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 			sub = (char *) subject.data;
 			len_s = strlen(sub);
 			process_charsets(&sub, &len_s, "UTF-8", tinrc.mm_local_charset, FALSE);
 			fprintf(fp, _(txt_conninfo_subject), sub);
-#else
+#		else
 			fprintf(fp, _(txt_conninfo_subject), subject.data);
-#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
+#		endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 		}
 
-		if ((result = gnutls_x509_crt_get_issuer_dn3(servercert, &issuer, 0)) < 0)
+		if (gnutls_x509_crt_get_issuer_dn3(servercert, &issuer, 0) < 0)
 			goto err_cert;
 		else {
-#if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
+#		if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 			iss = (char *) issuer.data;
 			len_i = strlen(iss);
 			process_charsets(&iss, &len_i, "UTF-8", tinrc.mm_local_charset, FALSE);
 			fprintf(fp, _(txt_conninfo_issuer), iss);
-#else
+#		else
 			fprintf(fp, _(txt_conninfo_issuer), issuer.data);
-#endif /* MULTIBYTE_ABLE && !NO_LOCALE */
+#		endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 		}
 
 		if ((t = gnutls_x509_crt_get_activation_time(servercert)) == -1)
 			goto err_cert;
 
 		tm = localtime(&t);
-		PRINT_VALID_BEFORE(tm, fmt_time);
+		if (t > startup_time)
+			val_time = FALSE;
+		PRINT_VALID_BEFORE(tm, fmt_time, val_time);
 
 		if ((t = gnutls_x509_crt_get_expiration_time(servercert)) == -1)
 			goto err_cert;
 
 		tm = localtime(&t);
-		PRINT_VALID_AFTER(tm, fmt_time);
+		if (t < startup_time)
+			val_time = FALSE;
+		PRINT_VALID_AFTER(tm, fmt_time, val_time);
 
 		retval = 0;
 
@@ -974,13 +1081,17 @@ err_cert:
 	}
 
 	return retval;
+	/* NOTREACHED */
 #	else
 
 #		ifdef USE_OPENSSL
+	const unsigned char *proto;
+	unsigned int proto_len;
 	long verification_result;
 	BIO *client = session_ctx;
 	SSL *ssl;
 	STACK_OF(X509) *chain;
+	t_bool val_time = TRUE;
 
 	if (BIO_get_ssl(client, &ssl) != 1L)
 		return -1;
@@ -996,6 +1107,10 @@ err_cert:
 	else
 		fprintf(fp, "%s", _(txt_conninfo_verify_successful));
 
+	SSL_get0_alpn_selected(ssl, &proto, &proto_len);
+	if (!proto_len)
+		fprintf(fp, "%s\n", _(txt_tls_no_alpn_negotiated));
+
 	fprintf(fp, "%s", _(txt_conninfo_server_cert_info));
 
 	if (verification_result == X509_V_OK)
@@ -1004,14 +1119,13 @@ err_cert:
 		chain = SSL_get0_verified_chain(ssl);
 
 	if (chain) {
-		char name[22]; /* %Y-%m-%dT%H:%M%z */
 		char **cert_info;
 		const ASN1_TIME *asn1;
 		int i;
 		struct tm tm;
 
 		for (i = 0; i < sk_X509_num(chain); i++) {
-			X509* cert = sk_X509_value(chain, i);
+			X509 *cert = sk_X509_value(chain, i);
 
 			if (i)
 				fputs("\n", fp);
@@ -1027,13 +1141,21 @@ err_cert:
 
 			if ((asn1 = X509_get0_notBefore(cert)) != NULL) {
 				if (ASN1_TIME_to_tm(asn1, &tm) == 1) {
-					PRINT_VALID_BEFORE(&tm, name);
+#			ifdef HAVE_MKTIME
+					if (mktime(&tm) > startup_time)
+						val_time = FALSE;
+#			endif /* HAVE_MKTIME */
+					PRINT_VALID_BEFORE(&tm, fmt_time, val_time);
 				}
 			}
 
 			if ((asn1 = X509_get0_notAfter(cert)) != NULL) {
 				if (ASN1_TIME_to_tm(asn1, &tm) == 1) {
-					PRINT_VALID_AFTER(&tm, name);
+#			ifdef HAVE_MKTIME
+					if (mktime(&tm) < startup_time)
+						val_time = FALSE;
+#			endif /* HAVE_MKTIME */
+					PRINT_VALID_AFTER(&tm, fmt_time, val_time);
 				}
 			}
 		}
@@ -1103,9 +1225,8 @@ show_errors(
 {
 	unsigned long next_error;
 
-	while ((next_error = ERR_get_error())) {
+	while ((next_error = ERR_get_error()))
 		error_message(0, msg_fmt, ERR_error_string(next_error, NULL));
-	}
 }
 #endif /* USE_OPENSSL */
 
@@ -1145,7 +1266,7 @@ log_func(
 		return;
 
 	if (msg[msglen - 1] == '\n')
-		msglen--;
+		--msglen;
 
 	debug_print_file("NNTP", "TLS%s%.*s [%d]", logtime(), msglen, msg, level);
 }
